//****************************************************************************//
//** ui.h extension file, included from the uic-generated form implementation.
//**
//** If you wish to add, delete or rename functions or slots use
//** Qt Designer which will update this file, preserving your code. Create an
//** init() function in place of a constructor, and a destroy() function in
//** place of a destructor.
//******************************************************************************//
#include <qfiledialog.h>
#include <qimage.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qtextedit.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qprocess.h>
#include <qfileinfo.h>
#include <qscrollview.h>
#include <qvbox.h>
#include <qlabel.h>
#include <qevent.h> // pour les events de la souris
#include <qmessagebox.h> //pour afficher les fenêtres d'erreur et d'information
#include <qapplication.h>  //pour qdebug
#include "fmwaiting.h"
#include <qwidget.h>
#include <qtimer.h>


 //globals variables

      //scrollview
     QScrollView*   _vueDefillante;  //scrollview
     QVBox*   _conteneur;
     QLabel*   _imageFils;  //display the chart
    
     //records on coordinates
     double _listeN[15]; //record all coordinates N
     double _listeE[15]; //record all coordinates E
     int _pixW[15]; //record all width wich correspond to coordinates
     int _pixH[15]; //record all height wich correspond to coordiknates
     int _nbPoint=0; //record number of coordinates
     
     //fm_waiting
     fmWaiting* _myWaiting;// permit to have the waiting form
     bool _out = false; //if cancel button on waiting form
    
     //info on open file
     QString* _chart;  //path of the chart
     QPainter* _p;   //paint of the chart
     QPixmap* _myPixmap;  //pixmap of the path
     QString* _chartName; //name of the new .kap chart
     QString* _chartTif; //name of the Tif file 12_ colors
    
     //process id
     int _idProcess=0; //process id : 1=convert, 2=tif2bsb
     //activate the installEvent on pixmap
     bool _chartEvent=false; //permit to activate or desactivate the chartEvent

     
void conversionTif2bsb::init()
{
    //create the link to www.justgic.com
    tbMagic->installEventFilter(this);
     tbMagic->setPaletteForegroundColor("blue");
    QFont magicFont("Arial",10);
    magicFont.setUnderline(true);
    tbMagic->setFont(magicFont);
    tbMagic->setCursor(Qt::PointingHandCursor);
    
    //create the link to mailto:franckBurgaudeau@yahoo.fr
     tbFranck->installEventFilter(this);
     tbFranck->setPaletteForegroundColor("blue");
     QFont franckFont("Arial",10);
     magicFont.setUnderline(true);
     tbFranck->setFont(magicFont);
     tbFranck->setCursor(Qt::PointingHandCursor);
   
    
    //create a QFont for label
    QFont myLabelFont("Arial",14, QFont::Bold - 60);
    lbRaster->setFont(myLabelFont);
    
    //initialize the scrollview
     _vueDefillante = new QScrollView(this, 0, 0);
     _vueDefillante->setMinimumSize(600,780); 
     _conteneur = new QVBox(_vueDefillante->viewport());
     _vueDefillante->addChild(_conteneur);
     _imageFils = new QLabel("No chart", _conteneur);   
     
     //we put Magic Instinct software in the copyright
     leCopyright->setText("Magic Instinct Software");
     sbGeo->setValue(_nbPoint);
     
     //set cbUnits to Deg/Min/Sec
     cbUnits->setCurrentItem(1);
     
     leDegLat2->show();
     leDegLat->hide();
     leMinLat->show();
     leMinLat2->hide();
     leSecLat->hide();
     
     leDegLong->hide();
     leDegLong2->show();
     leMinLong->show();
     leMinLong2->hide();
     leSecLong->hide();
     
     _out = false;
 }


/****************************************************/
  //
  //   SLOTS
  //
/****************************************************/


/*************************************************************/
// tbQuitClick() : tbQuit connected to clicked signal
// remove the old chart, delete all globals variables and close the application
/**************************************************************/
void conversionTif2bsb::tbQuitClick()
{
    if(leFile2convert->displayText() != "")
    { 
 QFileInfo* fi = new QFileInfo(leFile2convert->text());
              if(fi->extension() == "tif")
              {
    //path of the chart
    QString path= fi->dirPath(true);
                              //filename without extension
                              QString chart=fi->baseName();
                             //create filename.png
                              int indexPath=path.length();
                              path.insert(indexPath,"/");
                              int index=chart.length();
                             chart.insert(index,".png");
                             chart.insert(0,path);
     
                              QFile* fileOldChart = new QFile(chart);
                              if(fileOldChart->exists())
                              {
      fileOldChart->remove();
                              }       
           delete fileOldChart;
                              delete path;
              }
             else
              {
                             //path of the chart
                            QString path= fi->dirPath(true);
                            //filename without extension
                            QString chart=fi->baseName();
                            //create filename.png
                            int indexPath=path.length();
                            path.insert(indexPath,"/");
                            int index=chart.length();
                            chart.insert(index,".tif");
                            chart.insert(0,path);
     
                            QFile* fileOldChart = new QFile(chart);
                            if(fileOldChart->exists())
                            {
                                        fileOldChart->remove();
                            }
              delete fileOldChart;
              delete path;
             }
  delete fi;
     }
    //destroy all global variables
  
   delete _vueDefillante;
     delete _myWaiting;
     delete _chart;
     delete _p;   
     delete _myPixmap; 
     delete _chartName; 
     delete _chartTif; 
    
    //close application
    this->close();
}



/***********************************************/
//  pbnewPoint() : connected to pbNewPoint with clicked signal
//             enable the chart and draw all points recorded
/***********************************************/

void conversionTif2bsb::pbNewPoint()
{
    //we install the event filter
    _imageFils->setCursor(Qt::CrossCursor);
    _chartEvent = true;
    
    //paint all the points wich are validate  
    if(_nbPoint>=1)
    {
 int i;
              for(i=1; i<=_nbPoint; i++)
              {
                          draw(_pixW[i],_pixH[i],i);
              }
   }
     
    //how create a point
    information("Scroll the window to locate and click on known points.\nThen, enter the position of the selected point.\n"); 
    //pbValidpoint to enables in order to record it
    pbValidpoint->setEnabled(true);
}




/************************************************************/
//   valueChange() : spinBox sbGeo connected to valueChanged(int) signal  : 
// change coordinate switch point and cbUnits->currentText() (Deg or Deg/Min or Deg/Min/Sec)
/**************************************************************/
void conversionTif2bsb::valueChange()
{
    QString result;
    int value = sbGeo->value();
    QString valueUnit = cbUnits->currentText();
    
    //all fills to disable
    leDegLat->setEnabled(false);
    leDegLat->clear();
    leDegLat2->setEnabled(false);
    leDegLat2->clear();
    leMinLat->setEnabled(false);
    leMinLat->clear();
    leMinLat2->setEnabled(false);
    leMinLat2->clear();
    leSecLat->setEnabled(false);
    leSecLat->clear();
    
    leDegLong->setEnabled(false);
    leDegLong->clear();
    leDegLong2->setEnabled(false);
    leDegLong2->clear();
    leMinLong->setEnabled(false);
    leMinLong->clear();
    leMinLong2->setEnabled(false);
    leMinLong2->clear();
    leSecLong->setEnabled(false);
    leSecLong->clear();
    
    //in Degree
    if (valueUnit == "Deg")
    {
 //latitude
 QString degreeLat = QString::number(_listeN[value]);
              //search if there is minutes next the  .  : 18.12
              int point = degreeLat.find(".",0,true);
              if(point != -1)
 {
    degreeLat.truncate(point);
                              leDegLat->setText(degreeLat);
 }
 
             //longitude
             QString degreeLong = QString::number(_listeE[value]);
             //search if there is minutes next the  .  : 18.12
             point = degreeLong.find(".",0,true);
             if(point != -1)
             {
   degreeLong.truncate(point);
                             leDegLong->setText(degreeLong);
             }
    }
    
    //in Degree/Minutes
    if(valueUnit == "Deg/Min")
    {
 convertDeg2Min(value);
    }
    
    if(valueUnit == "Deg/Min/Sec")
    {
 convertDeg2Sec(value);
    }
    
    //change width and height value switch sbGeo->value()
    spPixWidth->setValue(_pixW[value]);
    spPixWidth->setEnabled(false);
    spPixHeight->setValue(_pixH[value]);
    spPixHeight->setEnabled(false);
    
    //we don't create a point
    if(!pbValidpoint->isEnabled())
    {
 //scroll the pixmap on the point
 _vueDefillante->setContentsPos(spPixWidth->value(),spPixHeight->value());
              _vueDefillante->update();
    }
}


/********************************************************/
// pbDeleteClicked() : pbDelete connected to clicked signal
// erase the selected point
/*******************************************************/
void conversionTif2bsb::pbDeleteClicked()
{
    //we look the point to delete
    int value = sbGeo->value();
    //we delete the point
    deletePoint(value);
    
    //we put to disable the delete button if there is no more points
    if(_nbPoint == 0)
    {
 pbDelete->setEnabled(false);
    }
    //we put to disable the button Create BSB file
    if(_nbPoint < 2)
    {
 tbOK->setEnabled(false);
    }
    
    sbGeo->setMaxValue(sbGeo->maxValue()-1);
    sbGeo->setValue(value);
        
    //draw all points on the pixmap
    int i;
    for(i=1; i<=_nbPoint; i++)
    {
 draw(spPixWidth->value(), spPixHeight->value(),i);
    }
}





/*************************************************************/
// pbValidPointClicked() : pbValidPoint connected to clicked signal
// record value point
/************************************************************/
void conversionTif2bsb::pbValidPointClicked()
{
    QString messError="Please enter :\n";
    bool ok = true;
   QString  value = cbUnits->currentText();
    //verify if all fills are not empty
    if(value == "Deg")
    {
 if(!(leDegLat->edited()) && (leDegLat->text().isEmpty()))
 {
                               messError+= "- Latitude degree\n";
                              ok = false;
              }
              if(!(leDegLong->edited()) && (leDegLong->text().isEmpty()))
              {
    messError += "- Longitude degree\n";
                              ok = false;
 }
    }
    if((value == "Deg/Min") || (value == "Deg/Min/Sec"))
    {
 if(!(leDegLat2->edited()) && leDegLat2->text().isEmpty())
 {
                             messError+= "- Latitude degree\n";
                             ok = false;
              }
              if(!(leDegLong2->edited()) && leDegLong2->text().isEmpty())
              {
    messError += "- Longitude degree\n";
                              ok = false;
              }
    }
    //when all coordinates are ok
    if(ok)
    {
 //record the point
 bool result = addSlot();
              if(result)
              {
    //paint on the chart the number of the point
    draw(spPixWidth->value(),spPixHeight->value(),_nbPoint);

                              //there is now at least a point so the user can change the spinBox value
                             sbGeo->setEnabled(true);
                             sbGeo->setMaxValue(_nbPoint);
                             sbGeo->setMinValue(1);
                             sbGeo->setValue(_nbPoint);
 
                              //disable all
                             leDegLat->setEnabled(false);
                             leDegLat2->setEnabled(false);
                             leMinLat->setEnabled(false);
                             leMinLat2->setEnabled(false);
                             leSecLat->setEnabled(false);
                             leDegLong->setEnabled(false);
                             leDegLong2->setEnabled(false);
                             leMinLong->setEnabled(false);
                             leMinLong2->setEnabled(false);
                             leSecLong->setEnabled(false);
                             cbNS->setEnabled(false);
                             cbEW->setEnabled(false);
                             spPixWidth->setEnabled(false);
                             spPixHeight->setEnabled(false);
 
  //disable event chart
  _chartEvent = false;
                            _imageFils->setCursor(Qt::ArrowCursor);
                            pbValidpoint->setEnabled(false);
     
                            //enable deletePoint when there is one or more points
                            if(_nbPoint >0)
                            {
    pbDelete->setEnabled(true);
                            }
                            //enable createPoint when 2 points or more
                            if(_nbPoint>=2)
                            { 
    tbOK->setEnabled(true);
                            }
             }
    }
    else
    {
 error(messError);
    }
}

/************************************************************/
//  tbBrowserClick() : tbBrowser connected to clicked signal
//  erase old chart and fills. Open a browser to choose a chart
/************************************************************/
void conversionTif2bsb::tbBrowserClick()
{
    //if it's not the fisrt chart,  erase all fills ans old chart
    if(leFile2convert->displayText() != "")
    { 
 //erase old recorded points
 int i;
             for(i=1; i<=_nbPoint; i++)
             {
   _listeN[i]=0;
                             _listeE[i]=0;
                _pixW[i]=0;
                             _pixH[i]=0;
             }
 
             QFileInfo* fi = new QFileInfo(leFile2convert->text());
             if(fi->extension() == "tif")
             {
   //path of the chart
   QString path= fi->dirPath(true);
                             //filename without extension
                             QString chart=fi->baseName();
                             //create filename.png
                            int indexPath=path.length();
                            path.insert(indexPath,"/");
                            int index=chart.length();
                            chart.insert(index,".png");
                            chart.insert(0,path);
     
                            QFile* fileOldChart = new QFile(chart);
                            if(fileOldChart->exists())
                            {
    fileOldChart->remove();
                            }
              delete fileOldChart;
              }
              else
              {
    //path of the chart
    QString path= fi->dirPath(true);
                             //filename without extension
                             QString chart=fi->baseName();
                             //create filename.png
                            int indexPath=path.length();
                            path.insert(indexPath,"/");
                            int index=chart.length();
                            chart.insert(index,".tif");
                            chart.insert(0,path);
     
  QFile* fileOldChart = new QFile(chart);
                            if(fileOldChart->exists())
                            {
    fileOldChart->remove();
                            }
                           delete fileOldChart;
                }
               delete fi;
    }
    
    //open the browser
    QString directory= QFileDialog::getOpenFileName( QString::null, "Images (*.tif *.bmp *.jpg *.jpeg *.gif *.png *.ppm)", this );
    if ( directory.isEmpty() )
    {
 error("Your chart is empty");
    }
    else 
    {
 //init all fills and variables
 int k;
              leScale->clear();
              leName->clear();
 leNumberChart->clear();
              leEdition->clear();
              leRelease->clear();
              spPixWidth->setValue(spPixWidth->minValue());
              spPixHeight->setValue(spPixHeight->minValue());
              sbGeo->setValue(sbGeo->minValue());
              for(k = 0; k<=_nbPoint; k++)
              {
    _listeN[k]=0;
                              _listeE[k]=0;
    _pixW[k]=0;
                              _pixH[k]=0;
               }
               _nbPoint = 0;
 
               //write the name of directory in leFile2convert
               leFile2convert->setText(directory);
 
               QFileInfo fi=directory;
 
               //i can't display .tif so I convert chart in .png
               if(fi.extension() == "tif")
               {
     //path of the chart
     QString path= fi.dirPath(true);
 
                              //filename without extension
                               QString chartName=fi.baseName();
 
                               //create filename.png
                              int indexPath=path.length();
                              path.insert(indexPath,"/");
                              int index=chartName.length();
                              chartName.insert(index,".png");
                              chartName.insert(0,path);
                             _chart = new QString(chartName);
     
                              convert(directory,chartName);
 }
 else
 {
                             _chart = new QString(leFile2convert->text());
                             //on affiche l'image dans le scrollview
                             _imageFils->setPixmap(QPixmap(directory)); 
              }
             _myPixmap = new QPixmap(*_chart);
             _p = new QPainter();
 
             //install event filter
             this->installEventFilter(this);
             _imageFils->installEventFilter(this);
 
             //enable groupBox2
             leName->setEnabled(true);
             leName->setText(fi.baseName());
             leNumberChart->setEnabled(true);
             leScale->setEnabled(true);
             leCopyright->setEnabled(true);
             cbGeoDat->setEnabled(true);
             cbSoundingDatum->setEnabled(true);
             cbUnitsMeters->setEnabled(true);
             spDrawingUnits->setEnabled(true);
             leEdition->setEnabled(true);
             leRelease->setEnabled(true);
 
            pbNew->setEnabled(true);
            pbHelp->setEnabled(true);
            cbUnits->setEnabled(true);
 
            //init limit chart pixel value
           spPixHeight->setMaxValue(_myPixmap->height());
           spPixWidth->setMaxValue(_myPixmap->width());
    }
}

/*****************************************************************/
// tbOkClick() : tbOk connected to clicked signal
// verify all fills and convert in bsb
/***************************************************************/
void conversionTif2bsb::tbOkClick()
{
    QString messError;
    bool ok = true;
    //on v�ifie si les donn�s ont bien ��enregistr�s
    if(leName->text() == "")
    {
 messError += "Please enter the chart name\n";
              ok = false;
    }
    if(leName->text().length() >= 70)
    {
 messError +="Your filename is too much long for bsb format (max. 80)i\n";
              ok = false;
    }
    if(leNumberChart->text()=="")
    {
	messError += "Your number chart\n";
    ok=false;
}
    if(leCopyright->text().length() >= 60)
    {
 messError += "Your copyright is too much long\n";
              ok = false;
    }      
    if(!leScale->edited())
    {
 messError += "Please enter the scale\n";
              ok = false;
    }
    if(!cbGeoDat->currentText())
    {
 messError += "please enter the Geodetic Datum\n";
              ok = false;
    }
    if(!cbSoundingDatum->currentText())
    {
 messError += "Please enter the Sounding Datum\n";
              ok = false;
    }
    if(!cbUnitsMeters->currentText())
    {
 messError += "Please enter your units\n";
              ok = false;
    }
    if(!leEdition->edited() || leEdition->text().length()!=10)
    {
 messError += "Please Enter the Edition\n";
              ok = false;
    }
    //verify date release
    QString date = leEdition->text();
    QString year = date.right(4);
    QString day = date.left(2);
    int place = date.find("/",0);
    QString month = date.mid(place+1,2);
    QDate myDate(year.toInt(),month.toInt(),day.toInt());
    if(!myDate.isValid())
    {
 messError += "Your edition date is not valid\n";
              ok = false;
    }
    
    if(!leRelease->edited() || leRelease->text().length()!=2)
    {
 messError += "Please enter the Release (2 numbers)\n";
              ok = false;
    }
    if(_nbPoint < 2)
    {
 messError += "Please enter at least 2 points\n";
              ok = false;
    }    
    //create the new file when all is ok 
    if(ok)
    {
       _chartName = new QString();
       *_chartName = QFileDialog::getSaveFileName(
                    "/home",
                    "Images (*.kap)",
                    this,
                    "save file dialog",
                    "Choose a filename to save under" );
      int index=_chartName->length();
      _chartName->insert(index,".kap"); 
              createKapFile( );
              tif2bsb();
    }
    //All the things to do before create the new file is in the error message
    else
    {
 error(messError);
    }
}


/*********************************************************/
// textChange() : cbUnits connected to textChange signal
//change Deg in Deg/Min or Deg/Min/Sec and all conversion
/*********************************************************/
void conversionTif2bsb::textChange()
{
    QString value = cbUnits->currentText();
    if(value == "Deg")
    {
	lbMin->hide();
              lbSec->hide();
 
	      //latitude
	      leDegLat->show();
	      if((leDegLat2->edited() || (!leDegLat2->text().isEmpty())) && (leMinLat->edited() || (!(leMinLat->text().isEmpty()))))
	      {
		  leDegLat->setText(QString::number(convertMin2Deg(leDegLat2->text(), leMinLat->text())));
	      }
	      if((leDegLat2->edited() || !leDegLat2->text().isEmpty()) && (leMinLat2->edited() || !leMinLat2->text().isEmpty()))
	      { 
		  leDegLat->setText(QString::number(convertSec2Deg(leDegLat2->text(), leMinLat2->text(), leSecLat->text())));
	      }
	      leDegLat2->hide();
	      leMinLat->hide();
	      leMinLat2->hide();
	      leSecLat->hide();
  
	      //longitude
	      leDegLong->show();
	      if((leDegLong2->edited() || ! leDegLong2->text().isEmpty()) && (leMinLong->edited() || !leMinLong->text().isEmpty()))
	      {
		  leDegLong->setText(QString::number(convertMin2Deg(leDegLong2->text(), leMinLong->text())));
	      }
	      if((leDegLong2->edited() || !leDegLong2->text().isEmpty()) && (leMinLong2->edited() || !leMinLong2->text().isEmpty()))
	      {
		  leDegLong->setText(QString::number(convertSec2Deg(leDegLong2->text(), leMinLong2->text(), leSecLong->text())));
	      }
	      leDegLong2->hide();
	      leMinLong->hide();
	      leMinLong2->hide();
	      leSecLong->hide();
    }
    
    if(value == "Deg/Min")
    {
 lbDeg->hide();
 lbMin->show();
 lbSec->hide();
 
 //latitude
 leDegLat->hide();
 leDegLat2->show();
 //origine degree
 if(leDegLat->edited() || !leDegLat->text().isEmpty())
 {
     QString degree = leDegLat->text();
     int point = degree.find(".",0,true);
     if(point != -1)
     {
  degree.truncate(point);
  leDegLat2->setText(degree);
     }
 }
 leMinLat->show();
 //cas ou on est en degr��l'origine
 if(leDegLat->edited() || !leDegLat->text().isEmpty())
 {
     QString minute = leDegLat->text();
     int point = minute.find(".",0,true);
     if(point != -1)
     {
  minute.remove(0,point);
  leMinLat->setText(QString::number(minute.toDouble()*60));
     }
 }
 //origin : Deg/Min/Sec
 if((leMinLat2->edited() || !leMinLat2->text().isEmpty()) && (leSecLat->edited() || !leSecLat->text().isEmpty()))
 {
     leMinLat->setText(QString::number(leMinLat2->text().toDouble() + leSecLat->text().toDouble()/60));
 }
 leMinLat2->hide();
 leSecLat->hide();
 
 //longitude
 leDegLong->hide();
 leDegLong2->show();
 //origin : degree
 if(leDegLong->edited() || !leDegLong->text().isEmpty())
 {
     QString degree = leDegLong->text();
     int point = degree.find(".",0,true);
     if(point != -1)
     {
  degree.truncate(point);
  leDegLong2->setText(degree);
     }
 }
 leMinLong->show();
 if(leDegLong->edited() || !leDegLong->text().isEmpty())
 {
     QString minute = leDegLong->text();
     int point = minute.find(".",0,true);
     if(point != -1)
     {
  minute.remove(0,point);
  leMinLong->setText(QString::number(minute.toDouble()*60));
     }
 }
 //origin : Deg/Min/Sec
 if((leMinLong2->edited() || !leMinLong2->text().isEmpty()) && (leSecLong->edited() || !leSecLong->text().isEmpty()))
 {
     leMinLong->setText(QString::number(leMinLong2->text().toDouble() + leSecLong->text().toDouble()/60));
 }
 leMinLong2->hide();
 leSecLong->hide();
 
     }
    if(value == "Deg/Min/Sec")
    {
 lbDeg->hide();
 lbMin->hide();
 lbSec->show();
 
 //latitude
 leDegLat->hide();
 leDegLat2->show();
 //origin : Degree
 if(leDegLat->edited() || !leDegLat->text().isEmpty())
 {
     QString degree = leDegLat->text();
     int point = degree.find(".",0,true);
     if(point != -1)
     {
  degree.truncate(point);
  leDegLat2->setText(degree);
     }
 }
 leMinLat->hide();
 leMinLat2->show();
              if(leDegLat->edited() || !leDegLat->text().isEmpty())
 {
     //on prend les degr� et on enl�e avant le point, ensuite on convertit en minute et on tronque le r�ultat
     QString minute = leDegLat->text();
     int point = minute.find(".",0,true);
     if(point != -1)
     {
  minute.remove(0,point);
  QString buff = QString::number(minute.toDouble()*60);
  point = buff.find(".",0,true);
  if(point != -1)
  {
      buff.truncate(point);
      leMinLat2->setText(buff);
  }
     }
 }
       //origin : degree/Min
 if(leMinLat->edited()  || !leMinLat->text().isEmpty())
 {
     //on prend les minutes et on tronque avant le point
     QString minute = leMinLat->text();
     int point = minute.find(".",0,true);
     if(point != -1)
     {
  minute.truncate(point);
  leMinLat2->setText(minute);
     }
 }
 leSecLat->show();
              if(leDegLat->edited() || !leDegLat->text().isEmpty())
 {
     QString seconde = leDegLat->text();
     int point = seconde.find(".",0,true);
     if(point != -1)
     {
  seconde.remove(0,point);
  QString buff = QString::number(seconde.toDouble()*60);
  point = buff.find(".",0,true);
  if(point != -1)
  {
      buff.remove(0,point);
      leSecLat->setText(buff);
  }
     }
 }
       //origin : Deg/Min
 if(leMinLat->edited() || !leMinLat->text().isEmpty())
 {
     QString seconde = leMinLat->text();
     int point = seconde.find(".",0,true);
     if(point != -1)
     {
  seconde.remove(0,point);
  leSecLat->setText(QString::number(seconde.toDouble()*60));
     }
 }
 
 //longitude
 leDegLong->hide();
 leDegLong2->show();
 if(leDegLong->edited() || !leDegLong->text().isEmpty())
 {
     QString degree = leDegLong->text();
     int point = degree.find(".",0,true);
     if(point != -1)
     {
  degree.truncate(point);
  leDegLong2->setText(degree);
     }
 }
 leMinLong->hide();
 leMinLong2->show();
 //origin : Dgeree
              if(leDegLong->edited() || !leDegLong->text().isEmpty())
 {
     QString minute = leDegLong->text();
     int point = minute.find(".",0,true);
     if(point != -1)
     {
  minute.remove(0,point);
  QString buff = QString::number(minute.toDouble()*60);
  point = buff.find(".",0,true);
  if(point != -1)
  {
      buff.truncate(point);
      leMinLong2->setText(buff);
  }
     }
 }
 //origin Deg/Min
 if(leMinLong->edited() || !leMinLong->text().isEmpty())
 {
                     QString minute = leMinLong->text();
                     int point = minute.find(".",0,true);
                     if(point != -1)
                     {
    minute.truncate(point);
                              leMinLong2->setText(minute);
        }
               }
               leSecLong->show();
  if(leDegLong->edited() || !leDegLong->text().isEmpty())
              {
                    
                     QString seconde = leDegLong->text();
                     int point = seconde.find(".",0,true);
                     if(point != -1)
                     {
                              seconde.remove(0,point);
                             QString buff = QString::number(seconde.toDouble()*60);
                             point = buff.find(".",0,true);
                             if(point != -1)
                             {
                                    buff.remove(0,point);
                                    leSecLong->setText(buff);
                             }
                      }
                  }
               if(leMinLong->edited() || !leMinLong->text().isEmpty())
               {
                      QString seconde = leMinLong->text();
                      int point = seconde.find(".",0,true);
                      if(point != -1)
                      {
                             seconde.remove(0,point);
                             leSecLong->setText(QString::number(seconde.toDouble()*60));
                      }
                }
    }
}
 

/********************************************************************/
// pbHelpClicked() : pbHelp connected to clicked signal
//display an help information
/********************************************************************/
void conversionTif2bsb::pbHelpClicked()
{
    information("Note : a minimum of 2 points are required\n Use 2 points not aligned on the same latitude and longitude axis\n For example, click at yhe left top corner and then at the right bottom corner to find these two points.\n You can repeat this operation with additionnal points in order to correct skewed charts (cause by deformation during scanning processs)\n For example, to check if meridians and parallels are well parallel together, click on the 2 opposite corner.\n");
}


/*******************************************************************************************/
//
//      Function
//
/*********************************************************************************************/

/**************************************************/
// eventFiletr( QObject *o, QEvent *e)
//  treat all events
/**************************************************/

bool conversionTif2bsb::eventFilter( QObject *o, QEvent *e)
{
    //draw all points on _imageFils (chart)
    if(_nbPoint>=1)
    {
 int i;
              for(i=1; i<=_nbPoint; i++)
              {
                          draw(spPixWidth->value(), spPixHeight->value(),i);
              }
   }
    //object = tbMagic : launch the browser at www.justmagic.com
    if(o == tbMagic)
    {
 if(e->type() == QEvent::MouseButtonPress)
 {
                              QStringList s;
    s<<"konqueror"<< "www.justmagic.com";
                              QProcess process(s);
                              process.start();
              }
     }
    
    //object = tbFranck : launch a mailto:franck_burgaudeau@yahoo.fr  
    if(o == tbFranck)
    {
 if(e->type() == QEvent::MouseButtonPress)
 {
                            QStringList s;
  s<<"mailto:franck_burgaudeau@yahoo.fr";
                            QProcess process(s);
                            process.start();
 }
    }

    //object = _imageFils : enable all fill to record a point and set height and width
    if(o == _imageFils)
    {
        
 if( e->type() == QEvent::MouseButtonPress && _chartEvent == true)
 {
                          //change event type to have mouse position 
                         QMouseEvent *m = (QMouseEvent *) e;
     
            //we erase the old point if it was not recorded
                         if(spPixWidth->value() != _pixW[_nbPoint] && spPixHeight->value() != _pixH[_nbPoint])
                         { 
                                _p->begin(_imageFils);
                                _p->eraseRect(spPixWidth->value()-5,spPixHeight->value()-5,10,10);
                                _p->end();
                          }
                          //increase nbPoint to know which point we have recorded
                          sbGeo->setValue(_nbPoint+1);
     
  //enable all fills
                           leDegLat->setEnabled(true);
              leDegLat->clear();
                           leDegLat2->setEnabled(true);
                           leDegLat2->clear();
                           leMinLat->setEnabled(true);
                           leMinLat->clear();
                           leMinLat2->setEnabled(true);
                           leMinLat2->clear();
                           leSecLat->setEnabled(true);
                           leSecLat->clear();
     
                           leDegLong->setEnabled(true);
                           leDegLong->clear();
                           leDegLong2->setEnabled(true);
                           leDegLong2->clear();
                           leMinLong->setEnabled(true);
                           leMinLong->clear();
                           leMinLong2->setEnabled(true);
                           leMinLong2->clear();
                           leSecLong->setEnabled(true);
                           leSecLong->clear();
     
                          cbNS->setEnabled(true);
                          cbEW->setEnabled(true);
     
                          //set height and width fills
                         //left top corner
                         if(m->x() < 5 && m->y() < 5)
                         {
        spPixWidth->setValue(0);
                                               spPixHeight->setValue(0);
                         }
                         else if(m->x() < _myPixmap->width() && m->x() > _myPixmap->width()-5  && m->y() < _myPixmap->height() && m->y() > _myPixmap->height()-5)
            {
        //right bottom  corner
        spPixWidth->setValue(_myPixmap->width());
                                  spPixHeight->setValue(_myPixmap->height());
                        }
                        else if( _myPixmap->width()-5 < m->x() < _myPixmap->width() &&   m->y() < 5)
                        {
       //right top corner
       spPixWidth->setValue(_myPixmap->width());
                                              spPixHeight->setValue(0);
                        }
                       else if(m->x() < 5 && m->y() < _myPixmap->height() && m->y() > _myPixmap->height()-5)
                       {
      //left bottom corner
      spPixWidth->setValue(0);
                                             spPixHeight->setValue(_myPixmap->height());
                       }
                       else
                       {
      spPixWidth->setValue(m->x());
                                             spPixHeight->setValue(m->y());
                        }
     
                       //draw a coss ans an ellipse
                      draw(spPixWidth->value(),spPixHeight->value(),_nbPoint);
    
                      //disable height and width pixmap spinBox 
                      spPixWidth->setEnabled(true);
                      spPixHeight->setEnabled(true);
 
                      return TRUE;
         }
         else
         {
      //when it doesn't dbl click on the chart
      return false;
         }
    } 
    else 
    {
 //when none events
 // standard event processing
 return FALSE;
    }
}


/*******************************************************/
//  deletePoint(int val)
// erase val point and display the nw selected point
/******************************************************/
void conversionTif2bsb::deletePoint( int val )
{
    int j = sbGeo->maxValue();
    int k;
    for (k=val ;k <= j ;k++)
    {
 _listeN[k] = _listeN[k+1]; 
              _listeE[k] = _listeE[k+1];
              _pixW[k]=_pixW[k+1];
              _pixH[k]=_pixH[k+1];
    }
    
   QString value = cbUnits->currentText();
    //we display the coordinates of the point wich is now at the place of the delete point
    if(value == "Deg")
    {
 leDegLat->clear();
              leDegLat->setText(QString::number(_listeN[val]));
              leDegLong->clear();
              leDegLong->setText(QString::number(_listeE[val]));
    }
    
    if(value == "Deg/Min")
    {
 //latitude
 //degree
 leDegLat2->clear();
             QString degree = QString::number(_listeN[val]);
             int sign = degree.find("-",0,true);
             int point = degree.find(".",0,true);
             if(sign != -1)
             {
   //it's an S coordinate
   cbNS->setCurrentItem(0);
                             degree.remove("-");
                             degree.truncate(point-1);
              }
 else
              {
                             //it's an N coordinate
                            cbNS->setCurrentItem(1);
                            degree.truncate(point);
              }
              leDegLat2->setText(degree);
              //minute
 leMinLat->clear();
              QString minute = QString::number(_listeN[val]);
              point = minute.find(".",0,true);
              minute.remove(0,point);
              leMinLat->setText(QString::number(minute.toDouble()*60));
 
              //longitude
              //degree
              leDegLong2->clear();
              degree = QString::number(_listeE[val]);
              point = degree.find(".",0,true);
              sign = degree.find("-",0,true);
              if(sign != -1)
              {
    //it's an E coordinate
    cbEW->setCurrentItem(0);
                              degree.remove("-");
                 degree.truncate(point-1);
 }
             else
             {
   //it's an W coordinate
   cbEW->setCurrentItem(1);
                             degree.truncate(point);
             }
             leDegLong2->setText(degree);
             //minute
            leMinLong->clear();
            minute = QString::number(_listeE[val]);
            point = minute.find(".",0,true);
            minute.remove(0,point);
            leMinLong->setText(QString::number(minute.toDouble()*60));
    }
    
    if(value == "Deg/Min/Sec")
    {
 //latitude
 //degree
 leDegLat2->clear();
              QString degree = QString::number(_listeN[val]);
              int sign = degree.find("-",0,true);
              int point = degree.find(".",0,true);
              if(sign != -1)
              {
    //it's an S coordinate
    cbNS->setCurrentItem(0);
                             degree.remove("-");
                             degree.truncate(point-1);
              }
             else
             {
   //it's an N coordinate
   cbNS->setCurrentItem(1);
                            degree.truncate(point);
             }
             leDegLat2->setText(degree);
             //minute
            leMinLat2->clear();
            QString minute = QString::number(_listeN[val]);
            leMinLat2->setText(QString::number(minute.toDouble()*60));
            //seconde
            leSecLat->clear();
            QString seconde = QString::number(_listeN[val]);
            point = seconde.find(".",0,true);
            seconde.remove(0,point);
            QString buff = QString::number(seconde.toDouble()*60);
            point = buff.find(".",0,true);
            buff.remove(0,point);
            leSecLat->setText(buff);
 
 
            //longitude
            //degree
           leDegLong2->clear();
           degree = QString::number(_listeE[val]);
           point = degree.find(".",0,true);
           sign = degree.find("-",0,true);
           if(sign != -1)
           {
        //it's an E coordinate
        cbEW->setCurrentItem(0);
        degree.remove("-");
        degree.truncate(point-1);
            }
           else
           {
        //it's an W coordinate
        cbEW->setCurrentItem(1);
        degree.truncate(point);
           }
           leDegLong2->setText(degree);
           //minute
           leMinLong2->clear();
           minute = QString::number(_listeE[val]);
           point = minute.find(".",0,true);
           minute.remove(0,point);
           leMinLong2->setText(QString::number(minute.toDouble()*60));
           //seconde
           seconde = QString::number(_listeE[val]);
           point = seconde.find(".",0,true);
           seconde.remove(0,point);
           buff = QString::number(seconde.toDouble()*60);
           point = buff.find(".",0,true);
           buff.remove(0,point);
           leSecLong->setText(buff);
    }
    
    
    spPixWidth->setValue(_pixW[val]);    
    spPixHeight->setValue(_pixH[val]);
    
    //we remove a point
    _nbPoint--;
}

/*****************************************************/
// convert(QString dir, QString name)
// convert the dir file to the name file with imageMagick(convert)
/*****************************************************/
bool conversionTif2bsb::convert(QString dir, QString name)
{
    QString directory=dir;
    QString newChart=name;
    QFileInfo fi(newChart);

    //it use ImageMagick-5.5.6-Q16
    QProcess* procConvert= new QProcess(this);
    procConvert->addArgument( "convert" );
    
    //we see if it's to convert in png or in tif
    if(fi.extension() == "tif")
    {
 procConvert->addArgument( "-colors");
              procConvert->addArgument("128");
    }
    procConvert->addArgument( directory );
    procConvert->addArgument( newChart);
    
    //start processus
     if ( !procConvert->start() ) 
    {
  // error handling
  error("Error when converting your chart");
               return false;
     }
    else
    {
              _idProcess=1;
 _myWaiting = new fmWaiting(this,"coucou",false,0);
              connect(procConvert, SIGNAL(processExited()), SLOT(onProcessExited()));
              _myWaiting->show();
              this->setCursor(Qt::WaitCursor);
              procConvert->start();
 if(!procConvert->start())
              {
                     // error handling
                    QMessageBox::critical( 0,tr("Fatal error"),tr("Could not start the uic command."),tr("Quit") );
                    return false;
              }
              if(_myWaiting->exec() == 2)
              {
                    procConvert->kill();
                   _out = true;
              }
              return true; 
    } 
    delete procConvert;
}

/**********************************************************************/
// convertDeg2Min(int value)
//display in Deg/Min
/*********************************************************************/
void conversionTif2bsb::convertDeg2Min(int value)
{
    QString degN = QString::number(_listeN[value]);
 
    QString degree = degN;
    //we search if the coordinate are N or S
    int sign = degN.find("-",0,true);
    int point = degN.find(".",0,true);
    if(sign != -1)
    {
 //it's a S coordinate
 cbNS->setCurrentItem(1);
              degree.remove("-");
       degree.truncate(point-1);
    }
    else
    {
 //it's a N coordinate
 cbNS->setCurrentItem(0);
              degree.truncate(point);
    }
    
    //we take only before the point for degree
    leDegLat2->setText(degree);
    
    //we take only next point for minutes
    QString min = degN.remove(0,point);
    leMinLat->setText(QString::number(min.toDouble() * 60));
    
    QString degE= QString::number(_listeE[value]);
    degree = degE;
    point = degE.find(".",0,true);
    sign = degE.find("-",0,true);
    if(sign == -1)
    {
 //it's an E coordinate
              cbEW->setCurrentItem(0);
             degree.truncate(point);
    }
    else
    {
 //it's an W coordinate
 cbEW->setCurrentItem(1);
             degree.remove("-");
             degree.truncate(point-1);
    }
    
    //we take only before the point for degree
    leDegLong2->setText(degree);
    
    //we take only next point for minutes
    min = degE.remove(0,point);
    leMinLong->setText(QString::number(min.toDouble() * 60));
}

/***************************************************************/
// convert Deg2Sec(int value)
//display in Deg/Min/Sec
/***************************************************************/
void conversionTif2bsb::convertDeg2Sec( int value )
{
    //latitude
    QString degN = QString::number(_listeN[value]);
    QString degree = degN;
    int point = degN.find(".",0,true);
    int sign = degN.find("-",0,true);
    if(sign != -1)
    {
 //it's a S coordinate
             cbNS->setCurrentItem(1);
             degree.remove("-");
             degree.truncate(point-1);
    }
    else
    {
             //it's a N coordinate
            cbNS->setCurrentItem(0);
            degree.truncate(point);
    }
    
    //we take only before the point for degree
    leDegLat2->setText(degree);
    
    //we take only next point for minutes
    QString min = degN.remove(0,point);
    QString minutes = QString::number(min.toDouble() * 60);
    point = minutes.find(".",0,true);
    
    min = minutes;
    min.truncate(point);
    leMinLat2->setText(min);
    
    QString sec = minutes.remove(0,point);
    double secN = sec.toDouble() * 60;
    leSecLat->setText(QString::number(secN));
    
    
    //longitude
    QString degE= QString::number(_listeE[value]);
    degree = degE; 
    sign = degE.find("-",0,true);
    point = degE.find(".",0,true);
    if(sign == -1)
    {
 //it's an E coordinate
 cbEW->setCurrentItem(0);
              degree.truncate(point);
    }
    else
    {
 //it's an W coordinate
 cbEW->setCurrentItem(1);
             degree.remove("-");
             degree.truncate(point-1); 
    }
    
    //we take only before the point for degree
    leDegLong2->setText(degree);
    
    //we take only next point for minutes
    min = degE.remove(0,point);
    minutes = QString::number(min.toDouble() * 60);
    point = minutes.find(".",0,true);
    
    min = minutes;
    min.truncate(point);
    leMinLong2->setText(min);
    
    sec = minutes.remove(0,point);
    double secE = sec.toDouble() * 60;
    leSecLong->setText(QString::number(secE));
}

/***************************************************************/
// convertMin2Deg(QString deg, QString min)
//display minute in Degree
/**************************************************************/
double conversionTif2bsb::convertMin2Deg( QString deg, QString min )
{
    double degre=deg.toDouble();
    double minute=min.toDouble();
    
    double inDegree=degre+(minute/60);
    return inDegree;
}

/***************************************************************/
// convertSec2Deg(QString deg, QString min, QString sec)
//display Deg/Min/Sec in degree
/***************************************************************/
double conversionTif2bsb::convertSec2Deg( QString deg, QString min, QString sec )
{
    double degre=deg.toDouble();
    double minute=min.toDouble();
    double seconde = sec.toDouble();
    
    double inDegree=degre+(minute/60) + ((seconde/60)/60);
    return inDegree;
}

/***************************************************************/
// createKapFile()
// create the template for the function tif2bsb
/***************************************************************/
void conversionTif2bsb::createKapFile()
{
    QString templateFile="template.kap";
    QFile  file(templateFile);
    
    QFileInfo name(*_chart);
    QString chartName(name.baseName());
     //open the template for writing
    if ( file.open( IO_WriteOnly | IO_Translate ) )
    {
 QTextStream stream( &file ); 
              //comments
              stream << "!Copyright : " << leCopyright->text() << "\n";
              //version du fichier BSB
              stream << "VER/2.0\x0D\x0A";
              //section BSB
             stream << "BSB/NA=" << leName->text() << "\x0D\x0A"; // chart name
             stream << "    NU=" << leNumberChart->text() << ",";
             //width, height calculate from the chart
             stream << "RA=" << _myPixmap->width() << "," << _myPixmap->height() << ",";
             stream << "DU=" << spDrawingUnits->value() << "\x0D\x0A"; //I don't know what it is
 
      //section KNP
             stream << "KNP/SC=" << leScale->text() << ","; //scale
             stream << "GD=" << cbGeoDat->currentText() << ",";
             stream << "PR=" << cbProjection->currentText() << "\x0D\x0A";
             stream << "    PP=0.000,";
             stream << "PI=UNKNOWN,";
             stream << "SP=UNKNOWN,";
             stream << "SK=0.0\x0D\x0A";
             stream << "    UN=" << cbUnitsMeters->currentText() << ",";
             stream << "SD=";
            int value = cbSoundingDatum->currentItem();
            switch (value)
            {
     case 0 : stream << "ESLW,"; break;
                  case 1 : stream << "HW,"; break;
                  case 2 : stream << "HAT,"; break;
                  case 3 : stream << "ISLW,"; break;
                  case 4 : stream << "MHHW,"; break;
                  case 5 : stream << "MHW,"; break;
                  case 6 : stream << "MHWS,"; break;
                  case 7 : stream << "MLW,"; break;
                  case 8 : stream << "MLWS,"; break;
                  case 9 : stream << "MLLW,"; break;
                  case 10 : stream << "MLLWS,"; break;
                  case 11 : stream << "MSL,"; break;
                  case 12 : stream << "MWL,"; break;
                  case 13 : stream << "LD,"; break;
                  case 14 : stream << "LW,"; break;
                  case 15 : stream << "LAT,"; break;
                  case 16 : stream << "LLW,"; break;
                  case 17 : stream << "LLWLT,"; break;
                  case 18 : stream << "LLWS,"; break;
             }
     
     double x(leScale->text().toInt()/10000),y=(leScale->text().toInt()/10000);
              int dx = int(x+0.5);
              int dy = int(y+0.5);
              stream << "DX=" << dx << "00,DY=" << dy << "00\x0D\x0A";
 
       //section CED
       stream << "CED/SE=" << leEdition->text().right(4) << ",RE=" << leRelease->text() << ",ED=" << leEdition->text() << "\x0D\x0A";
             //section OST
              stream << "OST/1\x0D\x0A";
 
       //section REF 
              int k;
              for(k=1; k<=_nbPoint; k++)
              {
    stream << "REF/" << k << "," << _pixW[k] << "," << _pixH[k] << "," << _listeN[k] << "," << _listeE[k] << "\x0D\x0A";
              }
 
       //section PLY
              stream << "PLY/1" << "," << _listeN[_nbPoint] << "," << _listeE[_nbPoint] << "\x0D\x0A";
              for(k=1;k<_nbPoint; k++)
              {
    stream << "PLY/" << k+1 << "," << _listeN[k] << "," << _listeE[k] << "\x0D\x0A";
              }
    }
    else
    {
 error("Couldn't create your template file");
    } 
}

/*****************************************************************/
// addSlot()
//record the point which the user have entered
/*****************************************************************/
bool conversionTif2bsb::addSlot()
{
    _nbPoint++;
     QString value = cbUnits->currentText();
     double degN = 0;
     double degE = 0;
     bool ok = true; //permet de savoir si les conversions se sont bien pass�

     if(value == "Deg")
     {
  if((0 <= leDegLat->text().toDouble()) && (leDegLat->text().toDouble()<= 90) && (0 <= leDegLong->text().toDouble()) &&  (leDegLong->text().toDouble() <= 180))
  {
                         degN = leDegLat->text().toDouble();
                         degE = leDegLong->text().toDouble();
               }
               else
              {
                         ok = false;
               }
     }
     if(value == "Deg/Min")
     {
  if((0 <= leDegLat2->text().toDouble()) && (leDegLat2->text().toDouble() <= 90) && (0 <= leMinLat->text().toDouble()) && (leMinLat->text().toDouble() <= 60) && (0 <= leDegLong2->text().toDouble()) && (leDegLong2->text().toDouble()<= 180) && (0 <= leMinLong->text().toDouble()) && (leMinLong->text().toDouble()<=60))
               {
                         degN = convertMin2Deg(leDegLat2->text(), leMinLat->text());
                         degE = convertMin2Deg(leDegLong2->text(), leMinLong->text());
               }
               else
              {
                        ok = false;
              }
     }
     if(value == "Deg/Min/Sec")
     {
  if((0 <= leDegLat2->text().toDouble()) && (leDegLat2->text().toDouble() <= 90) && (0 <= leMinLat2->text().toDouble()) && (leMinLat2->text().toDouble()<= 60) && (0 <= leDegLong2->text().toDouble()) &&  (leDegLong2->text().toDouble()<= 180) && (0 <= leMinLong2->text().toDouble()) && (leMinLong2->text().toDouble() <=60) && (0 <= leSecLat->text().toDouble()) && (leSecLat->text().toDouble()<=99) && (0 <= leSecLong->text().toDouble()) &&  (leSecLong->text().toDouble()<= 99))
  {
                         degN = convertSec2Deg(leDegLat2->text(), leMinLat2->text(), leSecLat->text());
                         degE = convertSec2Deg(leDegLong2->text(), leMinLong2->text(), leSecLong->text());
               }
              else
              {
    ok = false;
              }
     }
   
     if(ok == true)
     {
  //we look if we put a - before
  if(cbNS->currentText() == "N")
  {
                        _listeN[_nbPoint] = degN;
               } 
              else
               {
    _listeN[_nbPoint] = -degN;
               }
       //same thing
       if(cbEW->currentText() == "E")
       {
                       _listeE[_nbPoint] = degE;
              }
              else
              {
                       _listeE[_nbPoint] = -degE;
               }
              //record the width and height
              _pixW[_nbPoint] = spPixWidth->value();    
              _pixH[_nbPoint] = spPixHeight->value();
              return true;
     }
     else
     {
  //error when converting to double
  error("You have an error in your coordinate");
               _nbPoint--;
              return false;
     }
}


void conversionTif2bsb::onProcessExited()
{
   if(_out)
    {
       //user clicked on the cancel button on the waiting format
       information("You have interrupted the operation");
       _out = false;
       leFile2convert->clear();
    }
    else if(_idProcess == 2)
    { 
 _myWaiting->close();
    }
    else if(_idProcess == 1)
    {
 _imageFils->setPixmap(QPixmap(*_chart));
              _myWaiting->close();
    }
    this->setCursor(Qt::ArrowCursor);
}

/*****************************************************************/
// draw(int width, int height, int cpt)
//draw a point on the chart
/*****************************************************************/
void conversionTif2bsb::draw(int width, int height, int cpt)
{
    _p->begin(_imageFils);
    _p->setPen( red ); 
     //draw a cross
    _p->drawLine(width-5,height,width+5,height);
    _p->drawLine(width,height-5,width,height+5); 
    
    if(cpt != 0)
    {
 //put the point's number on the chart when it's on the corner
 if((width > _myPixmap->width()-20 && height > _myPixmap->height()-20))
 {
                       //if the point is on the right bottom corner
                      _p->drawText(_pixW[cpt]-10,_pixH[cpt]-10,QString::number(cpt),-1,QPainter::LTR);
                      _p->drawEllipse(_pixW[cpt]-15,_pixH[cpt]-15,30,30);
              }
              else if(width < 20 && height > _myPixmap->height()-20)
              {
                        //left bottom corner
                      _p->drawText(_pixW[cpt]+8,_pixH[cpt]-8,QString::number(cpt),-1,QPainter::LTR);
                      _p->drawEllipse(_pixW[cpt]-10,_pixH[cpt]-10,30,30);
              }     
             else if(width < 20 && height < 20)
 {
                     //left top corner
                      _p->drawText(_pixW[cpt]+8,_pixH[cpt]+8,QString::number(cpt),-1,QPainter::LTR);
                      _p->drawEllipse(_pixW[cpt]-10,_pixH[cpt]-10,30,30);
              }
             else if(width > _myPixmap->width()-20 && height < 20)
 {
                     //right top corner
                     _p->drawText(_pixW[cpt]-10,_pixH[cpt]+10,QString::number(cpt),-1,QPainter::LTR);
                     _p->drawEllipse(_pixW[cpt]-15,_pixH[cpt]-5,30,30);
               }
            else if(width < 20)
             {
                      //left
                     _p->drawText(_pixW[cpt]+8,_pixH[cpt],QString::number(cpt),-1,QPainter::LTR);
                     _p->drawEllipse(_pixW[cpt]-10,_pixH[cpt]-10,30,30);
             }
            else if(width > _myPixmap->width()-20)
           {
                     //right
                     _p->drawText(_pixW[cpt]-8,_pixH[cpt],QString::number(cpt),-1,QPainter::LTR);
                     _p->drawEllipse(_pixW[cpt]-10,_pixH[cpt]-10,30,30);
            }
           else if(width > _myPixmap->height()-20)
           {
                   //bottom
                   _p->drawText(_pixW[cpt],_pixH[cpt],QString::number(cpt),-1,QPainter::LTR);
                   _p->drawEllipse(_pixW[cpt]-10,_pixH[cpt]-10,30,30);
           }
           else
           {
                   _p->drawText(_pixW[cpt]+10,_pixH[cpt]+10,QString::number(cpt),QPainter::LTR);
                   _p->drawEllipse(_pixW[cpt]-10,_pixH[cpt]-10,30,30);
           }
    }
    _p->end();
} 

/*****************************************************************/
//  convertTif2bsb(QString tif, QString name)
//convert the tif file in bsb file using command : tif2bsb template.kap chart.tif chart.kap
/*****************************************************************/
bool conversionTif2bsb::convertTif2bsb( QString* tif, QString* name )
{
    
    QProcess* proc= new QProcess(this);
    // function : tif2bsb template.kap edited.tif newedited.kap
    proc->addArgument( "tif2bsb" );
    proc->addArgument( "template.kap" );
    proc->addArgument( *tif);
    proc->addArgument( *name);

    if ( !proc->start() ) 
    {
 // error handling
 return false;
     }
    else
    {
 _idProcess=2;
              _myWaiting = new fmWaiting(this,"coucou",false,0);;
              _myWaiting->show();
              this->setCursor(Qt::WaitCursor);
              connect(proc, SIGNAL(processExited()), SLOT(onProcessExited()));
              proc->start();
              if(!proc->start())
              {
                               // error handling
    QMessageBox::critical( 0,tr("Fatal error"),tr("Could not start the uic command."),tr("Quit") );
                              return false;
              }
              if(_myWaiting->exec() == 2)
              {
                            proc->kill();
                            _out = true;
             }
             return true;
    }
    delete proc;
}



/*********************************/
//  error(QString text)
//           display an error message (text)
/***********************************/

void conversionTif2bsb::error(QString text)
{
       switch( QMessageBox::warning( this, "Warning",
        text,
        "OK", 0, 0, 1 ) )
    case 0:  //the user click the ok buton
       break;
}

/**********************************************/
//  information(QString text)
//            display an information error (text)
/*********************************************/

void conversionTif2bsb::information(QString text)
{
        switch(QMessageBox::information( this, "Information",
        text,
       "OK", 0, 0, 1 ))
    case 0 : //the user click the ok button
 break;
}

/***************************************************************/
// tif2bsb() : 
// convert the original chart in .tif then convert in bsb
/***************************************************************/
//prepare le fichier .tif en 128 couleurs
void conversionTif2bsb::tif2bsb()
{
    QString directory=leFile2convert->text();
    QFileInfo fi=directory;
    //path of the chart
    QString path= fi.dirPath(true);
    
    //we convert the file in .tif because the function works only with tif2bsb
    //convertir en 128 couleurs
    //create filename.tif
    _chartTif= new QString(fi.baseName());
    int indexPath=path.length();
    path.insert(indexPath,"/");
    int index=_chartTif->length();
    _chartTif->insert(index,".tif");
    _chartTif->insert(0,path);
    //convert in Tif
    bool result = convert(directory,*_chartTif);
    
    if(result)
    {
 result = convertTif2bsb(_chartTif,_chartName);
              if(result)
              {
    information("Your bsb file has been created");
              }
   }
   else
   {
       error("Your file has not been converted");
   }
}
