#! /bin/sh

#################################################################
#
#	This script will install Qt 3.3.4, libtiff 3.7.2, libbsb 0.0.7
#	and RasterChart2BSB
#
##################################################################


#this installation will be done under root mode
ROOT_UID=0             # Root a l'identifiant utilisateur ($UID) 0.
if [ "$UID" -ne "$ROOT_UID" ]
  	then   
 		echo "Script execution need root privileges!"
		echo "type su to log on under root mode and execute the script"
		exit 0
	
	else


########################################
#	install Qt 3.3.4
########################################

cd RasterChart2BSB/package
		tar -zxf qt-x11-free-3.3.4.tar.gz
		cd qt-x11-free-3.3.4		
		#on écrit dans .profile les variables d'environnement
		echo QTDIR=/usr/local/qt >> .profile
		echo PATH=$QTDIR/bin:$PATH >> .profile
		echo MANPATH=$QTDIR/doc/man:$MANPATH >> .profile
		echo LD_LIBRARY_PATH=$QTDIR/lib:$LD_LIBRARY_PATH >> .profile
		echo export QTDIR ÄTH MANPATH LD_LIBRARY_PATH

		#in .login
		echo setenv QTDIR /usr/local/qt >> .login
		echo setenv PATH $QTDIR/bin:$PATH
		echo setenv MANPATH $QTDIR/doc/man:$MANPATH
		echo setenv LD_LIBRARY_PATH $QTDIR/lib:$LD_LIBRARY_PATH
		
		#build Qt
		./configure
		make
		make install
		
		echo "La librairie Qt est maintenant installée"


#######################################################################
#			install libraries
#######################################################################

#create include directory
################# 
cd ..
mkdir include
chmod 777 include


#####################################
#	libtiff 3.7.2
#####################################

#deploie la librairie tiff-3.7.2
echo "extract tiff-3.7.2.tar.gz ..."
tar -zxf tiff-3.7.2.tar.gz
mv tiff-3.7.2 include/tiff-3.7.2
rm -rf tiff-3.7.2

#install tiff-3.7.2
cd include/tiff-3.7.2
echo "install tiff-3.7.2 ...\n"
./configure
make
make install


######################################
#	libbsb 0.0.7
######################################

#prepare libbsb-0.0.7
ls
cd ../..
echo "extract libbsb-0.0.7 ..."
tar -zxf libbsb-0.0.7.tar.gz
mv libbsb-0.0.7 include/libbsb-0.0.7
rm -rf libbsb-0.0.7

#install libbsb-0.0.7
cd include/libbsb-0.0.7
echo "install libbsb-0.0.7 ..."
./configure
make
make install


########################################################
#
#		Install RasterChart2BSB
#
########################################################

cd ../../../src
echo "install RasterChart2BSB ..."
qmake -o makefile interfaceTif2bsb.pro
make
mv interfaceTif2bsb ../rasterChart2bsb

######################################################################
#
#			Install terminated
#
######################################################################
echo "The install is now terminated"

fi
